#include <Servo.h> 
 
Servo myservo;  // create servo object to control a servo 
#include <SoftwareSerial.h>

SoftwareSerial Serial2(10, 11); // RX, TX
int n=0;
int y;
long ys=0;
int dt=100;
long t0=millis();
int ym;
int cservo=0;
byte octet;
byte octet0=100;
float k1;
float k2;
int yref;
int pos;
int ym0;
int ma=1;
int dt2;
int vitt=0;
long t2=millis();


void setup() {
Serial.begin(9600);
Serial2.begin(9600);
Serial2.write(vitt);
myservo.attach(9);  // attaches the servo on pin 9 to the servo object 
myservo.write(90); 
yref=350;
k1=0.6;
k2=2;  
dt=100;
pinMode(3,OUTPUT);  // controle moteur traction
pinMode(5,OUTPUT); // controle moteur traction
digitalWrite(3,LOW);
digitalWrite(5,LOW);  
pinMode(6,OUTPUT); // controle moteur gyro
// lancement du moteur gyro

analogWrite(6,100);
delay(10000);
analogWrite(6,150);
delay(10000);
analogWrite(6,200);
delay(10000);
analogWrite(6,255);
Serial2.write(1);
}


void loop() {

 if(Serial2.available()){   
    octet = Serial2.read() ;
 }
if (octet != octet0) {
if(octet==0) cservo=0;
if(octet==1) cservo=1;  
if(octet==3) ma=1;
if(octet==4) ma=0;
if(octet==5) dt2=0;
if(octet==6) dt2=5;
if(octet==7) dt2=10;
if(octet==8) dt2=15;
if(octet==9) dt2=20;

if(octet==18) k1=0.4;
if(octet==19) k1=0.5;
if(octet==20) k1=0.6;
if(octet==21) k1=0.7;
if(octet==22) k1=0.8;
if(octet==30) k2=1.5;
if(octet==31) k2=2;
if(octet==32) k2=2.5;
if(octet==33) k2=3;
if(octet==34) k2=4;
if(octet==39) dt=50;
if(octet==40) dt=100;
if(octet==41) dt=150;
if(octet==42) dt=200;
if(octet==43) dt=250;
if(octet==148) yref=330;
if(octet==149) yref=340;
if(octet==150) yref=350;
if(octet==151) yref=360;
if(octet==152) yref=370;
if(octet==160) analogWrite(6,150);
if(octet==161) analogWrite(6,200);
if(octet==162) analogWrite(6,255);
octet0=octet;  
}

if (cservo==0) myservo.write(90);   

// stabilisation du gyro

if (cservo==1) {
 

n=n+1;





 y = analogRead(A1); 

ys=ys+y;
 
 if (millis()>t0+dt) {

 ym=(int)(ys/n);   
Serial.println(ym);
pos=89-k1*(ym-yref)-k2*(ym-ym0);


if (pos>150) pos=150;
if (pos<30) pos=30;
myservo.write(pos);     
ym0=ym;
n=0;
ys=0;
t0=millis();
 }

}

// commande moteur traction

if (ma==1) {
digitalWrite(5,LOW); 
if (millis()<t2+dt2) digitalWrite(3,HIGH);    
if (millis()>t2+dt2 && millis()<t2+20) digitalWrite(3,LOW);    
if (millis()>t2+20) t2=millis();
}

if (ma==0) {
digitalWrite(3,LOW); 
if (millis()<t2+dt2) digitalWrite(5,HIGH);    
if (millis()>t2+dt2 && millis()<t2+20) digitalWrite(5,LOW);    
if (millis()>t2+20) t2=millis();
}




      
}
